<?php
/*
Plugin Name: GS to WP
Author: Jacques Malgrange
Description: Import pages and media from GetSimple CMS to WordPress.
Version: 1.0
Author URI: http://www.boiteasite.fr
*/

if(is_admin())
	{
	add_action('init','gs2wp_locale');
	add_action('admin_menu','gs2wp');
	}
//
function gs2wp_locale()
	{
	load_plugin_textdomain('gs2wp',false,dirname(plugin_basename( __FILE__ )).'/lang'); // language
	}
//
function gs2wp()
	{
	add_submenu_page('tools.php', 'GetSimple to WordPress', 'GetSimple to WordPress', 'manage_options', 'gs2wp', 'gs2wp_admin');
	}
//
function gs2wp_admin()
	{
	if(!is_admin()) die();
	wp_enqueue_style('gs2wp', plugins_url(dirname(plugin_basename( __FILE__ )).'/css/gs2wp.css'));
	?>
	
	<div class='wrap gs2wp'>
		<h2>GetSimple to WordPress</h2>
		<?php if(!empty($_POST['import'])) gs2wp_action(); 
		else { ?>

		<p><?php _e('This plugin allows to import pages and media from GetSimple CMS to WordPress.', 'gs2wp'); ?></p>
		<ul>
			<li><?php _e('Copy the <strong>/data/</strong> folder from GetSimple.', 'gs2wp'); ?></li>
			<li><?php _e('Paste it into the <strong>/wp-content/uploads/</strong> folder of your WordPress.', 'gs2wp'); ?></li>
		</ul>
		<form method="post" name="gs2wp" action="tools.php?page=gs2wp">
			<?php wp_nonce_field(); ?>
			
			<input type="hidden" id="gs2wpImport" name="import" value="1" />
			<p class="submit">
				<input type="submit" class="button-primary" value="<?php _e('Check pages folder','gs2wp') ?>" />
			</p>
		<?php if(get_option('gs2wp')) { ?>
		
			<p class="submit">
				<input onClick="document.getElementById('gs2wpImport').value='9';" type="submit" class="button-primary" value="<?php _e('Cancel previous Import','gs2wp') ?>" />
			</p>
		<?php } ?>
			
		</form>
		<?php } ?>
		
	</div>
	<?php
	}
//
function gs2wp_action()
	{
	if(!is_admin()) die();
	global $upl; global $opt;
	$upl = wp_upload_dir();
	$opt = array('page'=>array(),'media'=>array());
	$d = $upl['basedir'].'/data/pages/';
	$x = gs2wp_readXMLDir($d);
	$import = intval(strip_tags($_POST['import']));
	// page.xml : pubDate, title, url, meta, metad, menu, menuOrder, menuStatus, template, parent, private, author, slug, filename
	// pages/xx.xml : pubDate, title, url, meta, metad, menu, menuOrder, menuStatus, template, parent, content, private, author
	$rep = array(
//		"src=&quot;/data/uploads"=>'src="'.$upl['baseurl'], // img SRC
		"&amp;nbsp;"=>" ",
		"&lt;"=>"<",
		"&gt;"=>">",
		"&nbsp;"=>" ",
		"&quot;"=>'"',
		"&amp;"=>"&"
		);
	$level = array(
		"top"=>0,
		"one"=>1,
		"two"=>2,
		"three"=>3,
		"four"=>4,
		"five"=>5
		);
	// Extract & Save Data
	$pages = array();
	foreach($x as $r)
		{
		$f = file_get_contents($r);
		$p = new SimpleXMLElement($f);
		$content = strtr((string)$p->content,$rep);
		$dat = (string)$p->pubDate; // Fri, 16 Sep 2016 17:57:19 +0200 -> 2016-09-16 17:57:19
		$dat = date('Y-m-d',strtotime(substr($dat,5,11))).' '.substr($dat,17,8);
		$pages[] = array(
			"title"=>(string)$p->title,
			"slug"=>(string)$p->url,
			"menu"=>(string)$p->menu,
			"menuOrder"=>((string)$p->menuOrder!='0'?(string)$p->menuOrder:'99'),
			"menuStatus"=>(string)$p->menuStatus,
			"template"=>(string)$p->template,
			"parent"=>(string)$p->parent,
			"metad"=>(string)$p->metad,
			"date"=>$dat,
			"content"=>$content,
			"wp_post_id"=>0
			);
		}
	usort($pages,'gs2wp_reorderMenu');
	$menu = array();
	$levelMax = 0;
	// 1. Top level - Empty parent
	for($i=0;$i<count($pages);++$i)
		{
		if(empty($pages[$i]['parent']))
			{
			$menu[$pages[$i]['slug']] = array("top",$i,0);
			}
		}
	// 2. Level 1
	for($i=count($pages)-1;$i>=0;--$i)
		{
		if(isset($menu[$pages[$i]['parent']]) && $menu[$pages[$i]['parent']][0]=="top")
			{
			if(!$levelMax) $levelMax = 1;
			$m = array();
			foreach($menu as $k=>$v)
				{
				$m[$k] = $v;
				if($k==$pages[$i]['parent']) $m[$pages[$i]['slug']] = array("one",$i,$v[1]);
				}
			$menu = $m;
			}
		}
	// 3. Level 2
	for($i=count($pages)-1;$i>=0;--$i)
		{
		if(isset($menu[$pages[$i]['parent']]) && $menu[$pages[$i]['parent']][0]=="one")
			{
			if($levelMax<2) $levelMax = 2;
			$m = array();
			foreach($menu as $k=>$v)
				{
				$m[$k] = $v;
				if($k==$pages[$i]['parent']) $m[$pages[$i]['slug']] = array("two",$i,$v[1]);
				}
			$menu = $m;
			}
		}
	// 4. Level 3
	for($i=count($pages)-1;$i>=0;--$i)
		{
		if(isset($menu[$pages[$i]['parent']]) && $menu[$pages[$i]['parent']][0]=="two")
			{
			if($levelMax<3) $levelMax = 3;
			$m = array();
			foreach($menu as $k=>$v)
				{
				$m[$k] = $v;
				if($k==$pages[$i]['parent']) $m[$pages[$i]['slug']] = array("three",$i,$v[1]);
				}
			$menu = $m;
			}
		}
	// 5. Level 4
	for($i=count($pages)-1;$i>=0;--$i)
		{
		if(isset($menu[$pages[$i]['parent']]) && $menu[$pages[$i]['parent']][0]=="three")
			{
			if($levelMax<4) $levelMax = 4;
			$m = array();
			foreach($menu as $k=>$v)
				{
				$m[$k] = $v;
				if($k==$pages[$i]['parent']) $m[$pages[$i]['slug']] = array("four",$i,$v[1]);
				}
			$menu = $m;
			}
		}
	// 6. Level 5
	for($i=count($pages)-1;$i>=0;--$i)
		{
		if(isset($menu[$pages[$i]['parent']]) && $menu[$pages[$i]['parent']][0]=="four")
			{
			if($levelMax<5) $levelMax = 5;
			$m = array();
			foreach($menu as $k=>$v)
				{
				$m[$k] = $v;
				if($k==$pages[$i]['parent']) $m[$pages[$i]['slug']] = array("five",$i,$v[1]);
				}
			$menu = $m;
			}
		}
	// *******************************
	if($import==1 && isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce']))
		{ ?>
		
		<form method="post" name="gs2wp" action="tools.php?page=gs2wp">
			<?php wp_nonce_field(); ?>
			
			<input type="hidden" name="import" value="2" />
			<table class="gs2wpTable">
				<tr>
					<th><?php _e('Select','gs2wp'); ?></th>
					<th><?php _e('Page name','gs2wp'); ?></th>
					<th><?php _e('Post format (not Page)','gs2wp'); ?></th>
				</tr>
		<?php foreach($menu as $k=>$v)
			{
			echo '<tr><td><input type="checkbox" name="i'.$v[1].'" checked="checked" /></td><td>';
			if($v[0]=='one') echo '- ';
			else if($v[0]=='two') echo '- - ';
			else if($v[0]=='three') echo '- - - ';
			else if($v[0]=='four') echo '- - - - ';
			else if($v[0]=='five') echo '- - - - - ';
			echo $k;
			echo '</td>';
			echo '<td><input type="checkbox" name="o'.$v[1].'" /></td>';
			echo '</tr>'."\r\n";
			} ?>

			</table>
			<div class="gs2wpOption">
				<div class="submit">
					<input type="submit" class="button-primary" value="<?php _e('Import selected pages','gs2wp'); ?>" />
				</div>
				<label><?php _e('Add pages in a menu','gs2wp'); ?> : </label>
				<select name="menu">
					<option value="1"><?php _e('Yes','gs2wp'); ?></option>
					<option value="0"><?php _e('No','gs2wp'); ?></option>
				</select>
				<br />
				<label><?php _e('Sub-pages level in the menu','gs2wp'); ?> : </label>
				<select name="level">
					<?php for($i=0; $i<=$levelMax; ++$i)
						{
						if(!$i) echo '<option value="0">[0]</option>';
						else echo '<option value="'.$i.'" '.($i==$levelMax?'selected':'').'>[0,'.$i.']</option>';
						} ?>
						
				</select>
				<br />
				<label><?php _e('Permalink','gs2wp'); ?> : </label>
				<select name="parent">
					<option value="0"><?php _e('Only display the page slug','gs2wp'); ?></option>
					<option value="1"><?php _e('Display all the parent pages','gs2wp'); ?></option>
				</select>
			</div>
		</form>
		<?php }
	// *******************************
	if($import==2 && isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce']))
		{
		wp_delete_nav_menu('menu_GS');
		$menu_id = wp_create_nav_menu('menu_GS');
		foreach($menu as $k=>$v)
			{
			echo $k.' - '.$pages[$v[1]]['date'].' : OK<br />';
			if(null==get_page_by_title($k) && !empty($_POST['i'.$v[1]]) && empty($_POST['o'.$v[1]])) // !exists && selected && not post
				{
				$cont = gs2wp_media($pages,$v);
				// Create page
				$p = array(
					'post_type' => 'page',
					'post_name' => $k,
					'post_parent' => ((!empty($_POST['parent']) && $pages[$v[2]]['wp_post_id'])?$pages[$v[2]]['wp_post_id']:''),
					'post_author' => get_current_user_id(),
					'post_status' => 'publish',
					'menu_order' => (($pages[$v[1]]['menuStatus']=='Y' && $pages[$v[1]]['menuOrder']!='99')?$pages[$v[1]]['menuOrder']:''),
					'post_date' => $pages[$v[1]]['date'],
					'post_title' => $pages[$v[1]]['title'],
					'post_content' => $cont,
					'meta_input' => array('metadesc' => $pages[$v[1]]['metad']) // WP 4.4
					);
				$pages[$v[1]]['wp_post_id'] = wp_insert_post($p);
				$opt['page'][] = $pages[$v[1]]['wp_post_id'];
				if(!empty($_POST['menu']) && intval(strip_tags($_POST['level']))>=$level[$v[0]] && $pages[$v[1]]['menuStatus']=='Y') // Add page to menu
					{
					$pages[$v[1]]['wp_menu_id'] = wp_update_nav_menu_item($menu_id, 0, array(
						'menu-item-type' => 'post_type',
						'menu-item-object' => 'page',
						'menu-item-object-id' => $pages[$v[1]]['wp_post_id'],
						'menu-item-parent-id' => (isset($pages[$v[2]]['wp_menu_id'])?$pages[$v[2]]['wp_menu_id']:0),
						'menu-item-title' =>  $pages[$v[1]]['title'],
						'menu-item-status' => 'publish')
						);
					}
				}
			else if(!post_exists($k) && !empty($_POST['i'.$v[1]]) && !empty($_POST['o'.$v[1]])) // !exists && selected && post
				{
				$cont = gs2wp_media($pages,$v);
				// Create post
				if($pages[$v[2]]['slug'] && !term_exists($pages[$v[2]]['slug'],'category')) $catid = wp_create_category($pages[$v[2]]['slug']); // parent slug
				$p = array(
					'post_type' => 'post',
					'post_name' => $k,
					'post_category' => array($catid),
					'post_author' => $user_ID,
					'post_status' => 'publish',
					'menu_order' => (($pages[$v[1]]['menuStatus']=='Y' && $pages[$v[1]]['menuOrder']!='99')?$pages[$v[1]]['menuOrder']:''),
					'post_date' => $pages[$v[1]]['date'],
					'post_title' => $pages[$v[1]]['title'],
					'post_content' => $cont
					);
				$pages[$v[1]]['wp_post_id'] = wp_insert_post($p);
				$opt['page'][] = $pages[$v[1]]['wp_post_id'];
				}
			}
		// HREF internal - end URL : id=slug or /slug/
		foreach($opt['page'] as $r)
			{
			$cont = get_post_field('post_content', $r);
			$c = 0;
			while($a = strpos(substr($cont,$c),'href="'))
				{
				$b = strpos(substr($cont,$c+$a+6),'"');
				if($b)
					{
					$b1 = substr($cont,$c+$a+6,$b);
					if(substr($b,-1)=='/') $b1 = substr($b1,0,-1);
					$x = explode('/',$b1);
					$b2 = $x[count($x)-1];
					if($b3 = strpos($b2,"?id=")) $b2 = substr($b2,$b3+4);
					$po = array('name'=>$b2,'post_type'=>'post','post_status'=>'publish','numberposts'=>1);
					$pa = array('name'=>$b2,'post_type'=>'page','post_status'=>'publish','numberposts'=>1);
					if($p = get_posts($po))
						{
						$cont = substr_replace($cont,get_post_permalink($p[0]->ID),$c+$a+6,$b);
						$pf = array('ID'=>$r,'post_content'=>$cont);
						wp_update_post($pf);
						}
					else if($p = get_posts($pa))
						{
						$cont = substr_replace($cont,get_post_permalink($p[0]->ID),$c+$a+6,$b);
						$pf = array('ID'=>$r,'post_content'=>$cont);
						wp_update_post($pf);
						}
					}
				$c += $a + 6;
				}
			}
		update_option('gs2wp',json_encode($opt));
		}
	// *******************************
	if($import==9 && isset($_POST['_wpnonce']) && wp_verify_nonce($_POST['_wpnonce'])) // cancel previous import
		{
		wp_delete_nav_menu('menu_GS');
		$a = json_decode(get_option('gs2wp'));
		if($a)
			{
			foreach($a->page as $r)
				{
				wp_delete_post($r,1);
				}
			foreach($a->media as $r)
				{
				$f = get_attached_file($r);
				wp_delete_attachment($r,1);
				}
			}
		delete_option('gs2wp'); ?>
		
		<script type='text/javascript'>window.location=document.location.href;</script>
		<?php
		}
	// *******************************
	}
//
function gs2wp_reorderMenu($a,$b)
	{
	return strcmp($a['menuOrder'],$b['menuOrder']);
	}
//
function gs2wp_media($pages,$v)
	{
	global $upl; global $opt;
	$cont = $pages[$v[1]]['content'];
	while($a = strpos($cont,'/data/uploads/'))
		{
		$b = strpos(substr($cont,$a+14),'"');
		if($b)
			{
			$img = substr($cont,$a+14,$b);
			$c = 0;
			if(file_exists($upl['basedir'].'/data/uploads/'.$img))
				{
				$time = current_time('mysql');
				$img2 = $upl['basedir'].'/'.substr($time,0,4).'/'.substr($time,5,2).'/'.basename($img);
				copy($upl['basedir'].'/data/uploads/'.$img, $img2);
				$ext = wp_check_filetype(basename($img),null);
				$att = array(
					'post_mime_type' => $ext['type'],
					'post_title' => preg_replace('/\.[^.]+$/','',basename($img)),
					'post_content' => '',
					'post_status' => 'inherit'
					);
				$imgId = wp_insert_attachment($att,$img2);
				if(!is_wp_error($imgId))
					{
					require_once(ABSPATH.'wp-admin/includes/image.php');
					$att_meta = wp_generate_attachment_metadata($imgId,$img2);
					wp_update_attachment_metadata($imgId,$att_meta);
					$c = 1;
					$cont = substr_replace($cont,wp_get_attachment_url($imgId),$a,14+$b);
					$opt['media'][] = $imgId;
					}
				}
			}
		if(!$c) $cont = substr_replace($cont,'',$a,14);
		}
	return $cont;
	}
function gs2wp_readXMLDir($d)
	{
	$x = array();
	if($h=opendir($d))
		{
		while(($file=readdir($h))!==false)
			{
			$ext = explode('.',$file);
			$ext = $ext[count($ext)-1];
			if($ext=='xml' && $file!='.' && $file!='..') $x[]=$d.$file;
			}
		closedir($h);
		}
	return $x;
	}
?>
